Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingMultimap<K,V>

All Implemented Interfaces:
  Multimap<K,V>

Direct Known Subclasses:
  ForwardingListMultimap, ForwardingSetMultimap

    @GwtCompatible
    public abstract class ForwardingMultimap<K,V>

extends ForwardingObject
implements Multimap<K,V>

A multimap which forwards all its method calls to another multimap. Subclasses should override one or more methods to modify the behavior of the backing multimap as desired per the decorator pattern.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Robert Konigsberg

Constructor Summary
`protected` | `ForwardingMultimap()` Constructor for use by subclasses.

Method Summary
`Map<K,Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
`void` | `clear()` Removes all key-value pairs from the multimap.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`protected abstract Multimap<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`Collection<Map.Entry<K,V>>` | `entries()` Returns a collection of all key-value pairs.
`boolean` | `equals(Object object)` Compares the specified object with this multimap for equality.
`Collection<V>` | `get(K key)` Returns a collection view of all values associated with a key.
`int` | `hashCode()` Returns the hash code for this multimap.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`Multiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`Set<K>` | `keySet()` Returns the set of all keys, each appearing once in the returned set.
`boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Stores a collection of values with the same key.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Copies all of another multimap's key-value pairs into this multimap.
`boolean` | `remove(Object key, Object value)` Removes a key-value pair from the multimap.
`Collection<V>` | `removeAll(Object key)` Removes all values associated with a given key.
`Collection<V>` | `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`Collection<V>` | `values()` Returns a collection of all values in the multimap.

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ForwardingMultimap

    protected ForwardingMultimap()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract Multimap<K,V> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingObject`

### asMap

    public Map<K,Collection<V>> asMap()

  Description copied from interface: `Multimap`
  Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue()` on its entries, `put`, or `putAll`.

  When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `Multimap.get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### clear

    public void clear()

  Description copied from interface: `Multimap`
  Removes all key-value pairs from the multimap.

  Specified by:
    `clear` in interface `Multimap<K,V>`

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### entries

    public Collection<Map.Entry<K,V>> entries()

  Description copied from interface: `Multimap`
  Returns a collection of all key-value pairs. Changes to the returned collection will update the underlying multimap, and vice versa. The entries collection does not support the `add` or `addAll` operations.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### get

    public Collection<V> get(@Nullable
                             K key)

  Description copied from interface: `Multimap`
  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  Specified by:
    `get` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### keys

    public Multiset<K> keys()

  Description copied from interface: `Multimap`
  Returns a collection, which may contain duplicates, of all keys. The number of times of key appears in the returned multiset equals the number of mappings the key has in the multimap. Changes to the returned multiset will update the underlying multimap, and vice versa.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### keySet

    public Set<K> keySet()

  Description copied from interface: `Multimap`
  Returns the set of all keys, each appearing once in the returned set. Changes to the returned set will update the underlying multimap, and vice versa.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### put

    public boolean put(K key,
                       V value)

  Description copied from interface: `Multimap`
  Stores a key-value pair in the multimap.

  Some multimap implementations allow duplicate key-value pairs, in which case `put` always adds a new key-value pair and increases the multimap size by 1. Other implementations prohibit duplicates, and storing a key-value pair that's already in the multimap has no effect.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates

### putAll

    public boolean putAll(K key,
                          Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Description copied from interface: `Multimap`
  Copies all of another multimap's key-value pairs into this multimap. The order in which the mappings are added is determined by `multimap.entries()`.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed

### remove

    public boolean remove(@Nullable
                          Object key,
                          @Nullable
                          Object value)

  Description copied from interface: `Multimap`
  Removes a key-value pair from the multimap.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed

### removeAll

    public Collection<V> removeAll(@Nullable
                                   Object key)

  Description copied from interface: `Multimap`
  Removes all values associated with a given key.

  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### replaceValues

    public Collection<V> replaceValues(K key,
                                       Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key, replacing any existing values for that key.

  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### values

    public Collection<V> values()

  Description copied from interface: `Multimap`
  Returns a collection of all values in the multimap. Changes to the returned collection will update the underlying multimap, and vice versa.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from interface: `Multimap`
  Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `Multimap.asMap()`, are also equal.

  In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

  A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `Multimap.asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `Multimap.asMap()` views.

  Specified by:
    `equals` in interface `Multimap<K,V>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Description copied from interface: `Multimap`
  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.